# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2024"
rust-version = "1.94.1"
name = "geiserx_ts_netstack_smoltcp_socket"
version = "0.42.0"
build = false
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "userspace netstack built on smoltcp (socket wrappers)"
readme = "README.md"
keywords = [
    "tailscale",
    "socket",
    "network",
    "smoltcp",
    "netstack",
]
categories = [
    "no-std",
    "network-programming",
]
license = "BSD-3-Clause"
repository = "https://github.com/GeiserX/tailscale-rs"

[features]
futures-io = [
    "dep:futures-io",
    "std",
]
std = ["ts_netstack_smoltcp_core/std"]
tokio = [
    "dep:tokio",
    "std",
]

[lib]
name = "ts_netstack_smoltcp_socket"
path = "src/lib.rs"

[dependencies.bytes]
version = "1"

[dependencies.futures-io]
version = "0.3"
optional = true

[dependencies.tokio]
version = "1"
features = [
    "rt-multi-thread",
    "macros",
    "time",
]
optional = true
default-features = false

[dependencies.tracing]
version = "0.1"
features = ["attributes"]
default-features = false

[dependencies.ts_netstack_smoltcp_core]
version = "0.42.0"
package = "geiserx_ts_netstack_smoltcp_core"

[dev-dependencies.tokio]
version = "1"
features = [
    "rt-multi-thread",
    "macros",
    "rt",
    "macros",
    "io-util",
    "time",
]
default-features = false

[lints.clippy]
multiple_crate_versions = "allow"
too_many_arguments = "allow"

[lints.clippy.cargo]
level = "warn"
priority = -1

[lints.rust]
closure_returning_async_block = "warn"
let-underscore = "warn"
missing_docs = "warn"

[lints.rustdoc]
bare_urls = "deny"
broken_intra_doc_links = "deny"
invalid_html_tags = "deny"
private_intra_doc_links = "deny"
